#!/usr/bin/sh
# shell script for building a *.deb package on Raspberry Pi/Wheezy platforms (Debian ARM)
# execute this script in the /installers/debian folder

# environment variables, change the following paths according to your needs

export AGENAVER="2.36.1"
# CHANGE version number in control file, as well !!!

export AGENAHOME="/home/pi/agena"
export MAINTARGETDIR="$AGENAHOME/installers/debian"
export AGENATARGET_USR="$MAINTARGETDIR/agena/usr"
export AGENATARGET_BIN="$MAINTARGETDIR/agena/usr/local/bin"
export AGENATARGET_LIB="$MAINTARGETDIR/agena/usr/local/lib"

# create directories if necessary

mkdir -p $AGENATARGET_USR/agena
mkdir -p $AGENATARGET_USR/agena/doc
mkdir -p $AGENATARGET_USR/agena/lib
mkdir -p $AGENATARGET_USR/agena/share
mkdir -p $AGENATARGET_USR/agena/share/icons
mkdir -p $AGENATARGET_USR/agena/share/schemes
mkdir -p $AGENATARGET_USR/agena/share/scripting
mkdir -p $AGENATARGET_BIN
mkdir -p $AGENATARGET_LIB

# Copy files to be distributed to target folders

# Documentation files
cp $AGENAHOME/doc/agena-crashcourse.pdf $AGENATARGET_USR/agena/doc
cp $AGENAHOME/doc/agena.pdf $AGENATARGET_USR/agena/doc
cp $AGENAHOME/doc/agena.xls $AGENATARGET_USR/agena/doc
cp $AGENAHOME/doc/ascii.xls $AGENATARGET_USR/agena/doc

# Library files
cp $AGENAHOME/lib/ads.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/ads.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/agenaini.spl $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/ansi.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/bags.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/bags.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/bimaps.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/heaps.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/heaps.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/compat.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/calc.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/calc.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/clock.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/mapm.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/mapm.agn $AGENATARGET_USR/agena/lib
#cp $AGENAHOME/lib/func.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/long.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/long.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/gzip.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/fractals.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/fractals.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/gdi.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/gdi.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/library.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/linalg.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/linalg.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/stats.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/stats.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/xbase.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/xbase.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/net.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/net.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/skycrane.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/skycrane.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/xml.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/xml.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/astro.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/astro.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/llist.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/llist.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/divs.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/cordic.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/hashes.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/hashes.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/tar.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/numarray.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/numarray.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/zx.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/bloom.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/factory.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/fastmath.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/bytes.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/sema.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/dual.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/dual.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/utf8.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/aconv.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/mp.agn $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/mp.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/mpf.so $AGENATARGET_USR/agena/lib
cp $AGENAHOME/lib/com.so $AGENATARGET_USR/agena/lib

# Scheme files
cp $AGENAHOME/share/schemes/agena.lang $AGENATARGET_USR/agena/share/schemes
cp $AGENAHOME/share/schemes/agena.xml $AGENATARGET_USR/agena/share/schemes
cp $AGENAHOME/share/schemes/agena.dat $AGENATARGET_USR/agena/share/schemes
cp $AGENAHOME/share/schemes/agena.sch $AGENATARGET_USR/agena/share/schemes
cp $AGENAHOME/share/schemes/nedit.rc $AGENATARGET_USR/agena/share/schemes
cp $AGENAHOME/share/schemes/readme.txt $AGENATARGET_USR/agena/share/schemes

# Share files
cp $AGENAHOME/share/icons/agena.ico $AGENATARGET_USR/agena/share/icons
cp $AGENAHOME/share/icons/agena256.ico $AGENATARGET_USR/agena/share/icons
cp $AGENAHOME/share/icons/aedit256.ico $AGENATARGET_USR/agena/share/icons
cp $AGENAHOME/share/icons/agena.png $AGENATARGET_USR/agena/share/icons
cp $AGENAHOME/share/icons/agena128x128.ico $AGENATARGET_USR/agena/share/icons
cp $AGENAHOME/share/icons/agena128x128.png $AGENATARGET_USR/agena/share/icons
cp $AGENAHOME/share/icons/agena64x64.ico $AGENATARGET_USR/agena/share/icons
cp $AGENAHOME/share/icons/agena64x64.png $AGENATARGET_USR/agena/share/icons
cp $AGENAHOME/share/icons/agena8b.gif $AGENATARGET_USR/agena/share/icons
cp $AGENAHOME/share/icons/agena8b.ico $AGENATARGET_USR/agena/share/icons
cp $AGENAHOME/share/icons/agenasmall.ico $AGENATARGET_USR/agena/share/icons
cp $AGENAHOME/share/icons/agenasmall.png $AGENATARGET_USR/agena/share/icons

# Scripting examples
cp $AGENAHOME/share/scripting/ln.agn $AGENATARGET_USR/agena/share/scripting
cp $AGENAHOME/share/scripting/getopt.agn $AGENATARGET_USR/agena/share/scripting
cp $AGENAHOME/share/scripting/whereis.agn $AGENATARGET_USR/agena/share/scripting
cp $AGENAHOME/share/scripting/whereis.bat $AGENATARGET_USR/agena/share/scripting
cp $AGENAHOME/share/scripting/whereis.cmd $AGENATARGET_USR/agena/share/scripting

# Change Log
cp $AGENAHOME/change.log $AGENATARGET_USR/agena
cp $AGENAHOME/wheezy.txt $AGENATARGET_USR/agena

# Binary and shared C libraries
cp $AGENAHOME/src/agena $AGENATARGET_BIN
#cp $AGENAHOME/src/libagena.so $AGENATARGET_LIB
cp $AGENAHOME/src/libagena.a  $AGENATARGET_LIB
#cp $AGENAHOME/../fltk-1.1.10/editor/agenaedit $AGENATARGET_BIN
cp $AGENAHOME/src/licence $AGENATARGET_USR/agena

# better sure than sorry: some distributions expect these libraries in /usr/lib instead of /usr/local/lib

ln --symbolic $AGENATARGET_LIB/libagena.so $AGENATARGET_USRLIB/libagena.so
ln --symbolic $AGENATARGET_LIB/libagena.a  $AGENATARGET_USRLIB/libagena.a

# position: owner & group & other
# 7 = read (1) + write (2) + execute (4) = 1 + 2 + 4 = 7
# 5 = read + execute
chmod -R 755 $AGENATARGET_USR/agena
chmod 755 $AGENATARGET_BIN agena

dpkg -b agena agena-$AGENAVER-raspi.stretch.armv6-32.deb

