/*
 * daytime.c
 *
 * Programmed by G. Adam Stanislav
 */
/* #include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h> */

#include <errno.h>
#include <fcntl.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>  /* 1.6.4, to avoid crashes with closed connections, signal() */


#ifdef _WIN32
#define FD_SETSIZE 4096  /* must be put before the #include of Winsock */
#include <winsock2.h>
#include <io.h>
#include <wininet.h>   /* for InternetGetConnectedState@ */
#else
/* header files for UNIX/Linux */
#include <sys/types.h>   /* to be put before sys/socket.h */
#ifdef __OS2__
/* better sure than sorry: on FreeBSD 6.4, <sys/socket.h> defines some macros that assume that NULL is defined. */
#include <stddef.h>
#endif
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <unistd.h>
#endif

int main() {
  register int s;
  register int bytes;
  struct sockaddr_in sa;
  char buffer[BUFSIZ + 1];
#ifdef _WIN32
  WORD wVersionRequested;
  WSADATA wsaData;
  /* initialise TCP for Windows (Winsock) */
  wVersionRequested = MAKEWORD(1, 1);
  if (WSAStartup(wVersionRequested, &wsaData) != 0) {
    int err = WSAGetLastError();
    printf("Error : initialisation of Winsock failed:\n(%d) %s", err, strerror(err));
    return 1;
  }
#endif
  if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    perror("socket");
    return 1;
  }
#ifndef _WIN32
  bzero(&sa, sizeof sa);
#else
  memset(&sa, 0, sizeof(sa));
#endif
  sa.sin_family = AF_INET;
  sa.sin_port = htons(13);
//sa.sin_addr.s_addr = htonl((((((192 << 8) | 43) << 8) | 244) << 8) | 18);
  sa.sin_addr.s_addr = htonl((((((129 << 8) |  6) << 8) | 15)  << 8) | 29);
  if (connect(s, (struct sockaddr *)&sa, sizeof sa) < 0) {
    perror("connect");
    close(s);
    return 2;
  }
  while ((bytes = read(s, buffer, BUFSIZ)) > 0) {
printf("loop\n");
    write(1, buffer, bytes);
  }
  printf("Bytes read: %d\n", bytes);
  close(s);
  return 0;
}
