/* Taken from the university website http://www.pcs.cnu.edu/~bbradie/ with the title:

											An Introduction to Numerical Analysis
											  with Applications to the Physical,
													Natural and Social Sciences

Provided or written by Professor Brian Bradie, Department of Mathematics, Christopher Newport University, VA.

There were no copyright notices on the site. Thus, Agena's MIT licence is _not_ applicable to this source code file
`interp.h`. */


#ifndef interp_h
#define interp_h

long double  neville (int, long double*, long double*, long double);
long double  dneville (int, LongDoubleArray*, LongDoubleArray*, long double);

long double  *divdiff (int, long double*, long double*);
long double  *ddivdiff (int n, LongDoubleArray *x, LongDoubleArray *y);

long double  nf_eval (int, long double*, long double*, long double);
int     cubic_nak (int, long double*, long double*, long double*, long double*, long double*);
int     cubic_clamped (int, long double*, long double*, long double*, long double*, long double*, long double, long double);
long double  spline_eval (int, long double*, long double*, long double*, long double*, long double*, long double);

#endif
