#ifndef long_h
#define long_h

#include "lstate.h"
#include "sunpro.h"

#define longdouble long double

#define DLong ieee_long_double_shape_type

#define checkdlong(L, n) (DLong *)luaL_checkudata(L, n, "longdouble")

#define getdlongvalue(L,idx) (((DLong *)lua_touserdata(L, (idx)))->value)

#define checkandgetdlong(L,idx) (((DLong *)luaL_checkudata(L, (idx), "longdouble"))->value)

#define checkandgetdlongnum(L,idx) ({ \
  longdouble __x = (agn_isnumber(L, (idx))) ? agn_tonumber(L, (idx)) : (checkandgetdlong(L, (idx))); \
  (__x); \
})

#define tolong(L,idx,ds)  (lua_isnumber(L, (idx)) ? ds.d : ds.f)

#define agnL_checkdlongnum(L,idx,procname) ({ \
  longdouble __x; \
  if (agn_isnumber(L, (idx))) { \
    __x = agn_tonumber(L, (idx)); \
  } else if (agnL_isdlong(L, (idx))) { \
    __x = getdlongvalue(L, (idx)); \
  } else { \
    __x = 0.0L; \
    luaL_error(L, "Error in " LUA_QS ": number or longdouble expected, got %s.", procname, luaL_typename(L, idx)); \
  } \
  (__x); \
})

#define checkandgetdlongint(L,idx) ({ \
  longdouble __x = (agn_isnumber(L, (idx))) ? agn_tonumber(L, (idx)) : (checkandgetdlong(L, (idx))); \
  (sun_intl(__x)); \
})

#define getdlongnum(L,d,idx,procname) { \
  if (agn_isnumber(L, (idx))) { \
    d.d = agn_tonumber(L, (idx)); \
  } else if (agnL_isdlong(L, (idx))) { \
    d.f = getdlongvalue(L, (idx)); \
  } else { \
    luaL_error(L, "Error in " LUA_QS ": number or longdouble expected, got %s.", procname, luaL_typename(L, idx)); \
  } \
}

#define createdlong(L,x) { \
  DLong *__d = (DLong *)lua_newuserdata(L, sizeof(DLong)); \
  lua_setmetatabletoobject(L, -1, "longdouble", 1); \
  __d->value = (x); \
}

#endif
