@echo off
rem To build and install the additional libraries, execute this file in the \agena\src subfolder
rem in a plain NT shell, and not in MinGW.

set gccopts=-Wall -Wno-attributes -pipe -O3 -shared -I. -L. -lagena -fgnu89-inline
rem -Wno-maybe-uninitialized
set gccfileopts=-pipe -O3 -DLUA_BUILD_AS_DLL -fgnu89-inline -Wno-attributes
set gccfinalopts=-pipe -O3 -shared -static-libgcc -fpic -fgnu89-inline -Wno-attributes
set offs=-Wno-int-to-pointer-cast -Wno-pointer-to-int-cast

set OLDPATH=%PATH%
set PATH=%PATH%;c:\mingw\bin

del ads.o calc.o linalg.o stats.o fractals.o phq.o net.o xbase.o interp.o rlhmath.o astro.o skycrane.o llist.o hashes.o factory.o sunriset.o moon.o fastmath.o bytes.o sema.o dual.o utf8.o aconv.o com.o xml.o gzip.o mp.o mpf.o heaps.o mapm.o long.o

echo Building ADS.
gcc %offs% %gccfileopts% -c -o ads.o ads.c
gcc -O3 -shared -static-libgcc -fgnu89-inline -fpic -o ads.dll ads.o vecoff64.o -L. -lagena

rem echo Building phonetiQs.
rem gcc %gccopts% -o phq.dll plus/phq.c
rem copy phq.dll ..\phq >> NUL
rem del phq.dll

echo Building calc.
gcc %gccfileopts% -c -o calc.o calc.c
gcc %gccfileopts% -c -o interp.o interp.c
gcc %gccfileopts% -c -o rlhmath.o rlhmath.c
gcc %gccfinalopts% -o calc.dll calc.o interp.o cephes.o rlhmath.o -L. -lagena

echo Building stats.
gcc %gccfileopts% -c -o stats.o stats.c
gcc %gccfinalopts% -o stats.dll stats.o cephes.o -L. -lagena

echo Building linalg.
gcc %gccopts% -o linalg.dll linalg.c

echo Building fractals.
gcc %gccopts% -o fractals.dll fractals.c

echo Building astro.
gcc %gccfileopts% -c -o sunriset.o sunriset.c
gcc %gccfileopts% -c -o moon.o moon.c
gcc %gccfileopts% -c -o astro.o astro.c
gcc %gccfinalopts% -o astro.dll astro.o agnt64.o sofa.o sdncal.o moon.o sunriset.o -L. -lagena

echo Building xbase.
gcc %gccfileopts% -c -o xbase.o xbase.c
gcc %gccfinalopts% -o xbase.dll xbase.o sofa.o agnt64.o -L. -lagena

echo Building net.
gcc %gccfileopts% -c -o net.o net.c
gcc %gccfinalopts% -o net.dll net.o -L. -lwsock32 -lwininet -lagena

echo Building bags.
gcc %gccopts% -o bags.dll bags.c

echo Building skycrane.
gcc %gccopts% -o skycrane.dll skycrane.c

echo Building llist.
gcc %gccopts% -o llist.dll llist.c

echo Building hashes.
gcc %gccopts% -o hashes.dll hashes.c

rem echo Building compress.
rem gcc %gccopts% -o compress.dll compress.c lcompress.c agnhlps.c

rem echo Building words.
rem gcc %gccopts% -o words.dll words.c

echo Building numarray.
gcc %gccopts% -o numarray.dll numarray.c

echo Building zx.
gcc %gccopts% -o zx.dll zx.c

echo Building bloom.
gcc %gccopts% -o bloom.dll bloom.c

echo Building factory.
gcc %gccopts% -o factory.dll factory.c

echo Building fastmath.
gcc %gccopts% -Wno-strict-aliasing -o fastmath.dll fastmath.c

echo Building sema.
gcc %gccfileopts% -c -o sema.o sema.c
gcc %gccfileopts% -c -o semalib.o semalib.c
gcc %gccfinalopts% -o sema.dll sema.o semalib.o -L. -lagena

echo Building dual.
gcc %gccopts% -o dual.dll dual.c

echo Building utf8.
gcc %gccopts% -o utf8.dll utf8.c

echo Building mp.
set gmpopts=-Wall -O3 -fgnu89-inline -shared -I. -L.
set gmplibs=-lgmp -lagena
gcc %gmpopts% -o mp.dll mp.c %gmplibs%

echo Building mpf.
set mpfropts=-Wall -O3 -fgnu89-inline -shared -I. -L.
set mpfrlibs=-lmpfr -lgmp -lagena
gcc %mpfropts% -o mpf.dll mpf.c %mpfrlibs%

echo Building bytes.
set gccopts=-Wall -DPLUS -O3 -shared -I. -L. -lagena -fgnu89-inline
gcc %gccopts% -o bytes.dll bytes.c charbuf.c

echo Buildung com.
set gccopts=-Wall -DPLUS -O3 -shared -I. -L. -lagena -fgnu89-inline
gcc %gccopts% -o com.dll com.c luasys.c charbuf.c

echo Buildung aconv.
set gccopts=-Wall -O3 -shared -I. -L. -lagena -fgnu89-inline
set aconvlibs=-lagena -liconv
gcc %gccopts% -o aconv.dll aconv.c %aconvlibs%

echo Buildung xml.
set gccopts=-Wall -O3 -shared -I. -L. -lagena -fgnu89-inline
set expatlibs=-lagena -lexpat
gcc %gccopts% -o xml.dll xml.c %expatlibs%

echo Buildung gzip.
set gccopts=-Wall -O3 -shared -I. -L. -lagena -fgnu89-inline
set zlibs=-lagena -lz
gcc %gccopts% -o gzip.dll gzip.c %zlibs%

echo Buildung mapm.
set gccopts=-Wall -O3 -shared -I. -L. -lagena -fgnu89-inline
set mapmlibs=-lagena -lmapm
gcc %gccopts% -o mapm.1.dll mapm.c %mapmlibs%
rename mapm.1.dll mapm.dll

echo Buildung long.
set gccopts=-Wall -O3 -shared -I. -L. -lagena -fgnu89-inline
gcc %gccopts% -o long.dll long.c

echo Building heaps.
gcc %gccopts% -o heaps.dll heaps.c

rem echo Buildung func.
rem set gccopts=-Wall -O3 -shared -I. -L. -lagena -fgnu89-inline
rem gcc %gccopts% -o func.dll func.c

rem strip --strip-unneeded *.dll  MinGW/GCC 10.x's strip does not accept wildcards any longer
echo.
echo Slimming and moving packages.
strip --strip-unneeded ads.dll
copy ads.dll ..\lib >> NUL
strip --strip-unneeded calc.dll
copy calc.dll ..\lib >> NUL
strip --strip-unneeded stats.dll
copy stats.dll ..\lib >> NUL
strip --strip-unneeded linalg.dll
copy linalg.dll ..\lib >> NUL
strip --strip-unneeded fractals.dll
copy fractals.dll ..\lib >> NUL
strip --strip-unneeded xbase.dll
copy xbase.dll ..\lib >> NUL
strip --strip-unneeded net.dll
copy net.dll ..\lib >> NUL
strip --strip-unneeded bags.dll
copy bags.dll ..\lib >> NUL
strip --strip-unneeded astro.dll
copy astro.dll ..\lib >> NUL
strip --strip-unneeded skycrane.dll
copy skycrane.dll ..\lib >> NUL
strip --strip-unneeded llist.dll
copy llist.dll ..\lib >> NUL
strip --strip-unneeded hashes.dll
copy hashes.dll ..\lib >> NUL
strip --strip-unneeded numarray.dll
copy numarray.dll ..\lib >> NUL
strip --strip-unneeded zx.dll
copy zx.dll ..\lib >> NUL
strip --strip-unneeded bloom.dll
copy bloom.dll ..\lib >> NUL
strip --strip-unneeded factory.dll
copy factory.dll ..\lib >> NUL
strip --strip-unneeded fastmath.dll
copy fastmath.dll ..\lib >> NUL
strip --strip-unneeded bytes.dll
copy bytes.dll ..\lib >> NUL
strip --strip-unneeded sema.dll
copy sema.dll ..\lib >> NUL
strip --strip-unneeded dual.dll
copy dual.dll ..\lib >> NUL
strip --strip-unneeded utf8.dll
copy utf8.dll ..\lib >> NUL
strip --strip-unneeded mp.dll
copy mp.dll ..\lib >> NUL
strip --strip-unneeded mpf.dll
copy mpf.dll ..\lib >> NUL
strip --strip-unneeded com.dll
copy com.dll ..\lib >> NUL
strip --strip-unneeded aconv.dll
copy aconv.dll ..\lib >> NUL
strip --strip-unneeded xml.dll
copy xml.dll ..\lib >> NUL
strip --strip-unneeded gzip.dll
copy gzip.dll ..\lib >> NUL
strip --strip-unneeded heaps.dll
copy heaps.dll ..\lib >> NUL
strip --strip-unneeded mapm.dll
copy mapm.dll ..\lib >> NUL
strip --strip-unneeded long.dll
copy long.dll ..\lib >> NUL
rem strip --strip-unneeded func.dll
rem copy func.dll ..\lib >> NUL

echo Installed all libraries into Agena /lib folder.

del ads.dll
del calc.dll
del stats.dll
del linalg.dll
del fractals.dll
del xbase.dll
del net.dll
del bags.dll
del astro.dll
del skycrane.dll
del llist.dll
del hashes.dll
del numarray.dll
del zx.dll
del bloom.dll
del factory.dll
del fastmath.dll
del bytes.dll
del sema.dll
del dual.dll
del utf8.dll
del mp.dll
del mpf.dll
del com.dll
del aconv.dll
del xml.dll
del gzip.dll
del heaps.dll
del mapm.dll
del long.dll
rem del func.dll

set gccopts=
set zlibs=
set mapmlibs=
set expatlibs=
set aconvlibs=
set mpfrlibs=
set gmplibs=
set PATH=%OLDPATH%
set OLDPATH=