#ifndef numarray_h
#define numarray_h

typedef struct NumArray {
  size_t size;         /* number of slots */
  char datatype;       /* is array a double (==1), int32_t (==2), uint16_t (==3) or uint32_t (==4) uchar (==0) array ? */
  union data {
    lua_Number *n;     /* pointer to lua_Number values */
    unsigned char *c;  /* pointer to char values */
    int32_t *i;        /* pointer to signed 32-bit integers */
    uint32_t *ui;      /* pointer to unsigned 32-bit integers */
    uint16_t *us;      /* pointer to unsigned 16-bit integers */
    long double *ld;   /* pointer to 80-bit floating-point nunbers */
  } data;
  int registry;        /* registry, for attribute information, stored to index 0; 2.15.1 */
} NumArray;

#define checknumarray(L,n) (NumArray *)luaL_checkudata(L, n, "numarray")
#define isnumarray(L,n)    (luaL_isudata(L, n, "numarray"))

#endif

