#ifndef strarray_h
#define strarray_h

typedef struct StrArray {
  size_t size;         /* number of slots */
  char datatype;       /* is array a double (==1), int32_t (==2), uint16_t (==3) or uchar (==0) array ? */
  union data {
    lua_Number *n;     /* pointer to lua_Number values */
    unsigned char *c;  /* pointer to char values */
    int32_t *i;        /* pointer to signed int values */
    uint16_t *us;      /* pointer to unsigned short values */
  } data;
  int registry;        /* registry, for attribute information, stored to index 0; 2.15.1 */
} StrArray;

#define checkstrarray(L,n) (StrArray *)luaL_checkudata(L, n, "strarray")
#define isstrarray(L,n)    (luaL_isudata(L, n, "strarray"))

#endif
